package dareka;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ConnectException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 
 * Server 󂯂RlNV1 Thread 蓖Ă
 * 
 */
public class ConnectionProcessor implements Runnable {
    /**
     * eʐMɎgobt@̃TCY
     */
    private static final int BUF_SIZE = 32 * 1024;
    /**
     * SMILEVIDEO̓URL̐K\
     */
    // http://s-clb5.smilevideo.jp/smile?v=102982.92382
    private static final Pattern SM_FLV_PATTERN = Pattern
            .compile("GET http://[^/]+(?:smilevideo|nicovideo)\\.jp/smile\\?v=([^.]+)\\.\\d+(low)?");
    /**
     * HTTPX|XOK̐K\
     */
    private static final Pattern HTTP_OK_PATTERN = Pattern
            .compile("^HTTP/1.[01] 200 ");
    /**
     * HTTPNGXg̃\bhs̐K\
     */
    private static final Pattern METHOD_LINE_PATTERN = Pattern
            .compile("^([A-Z]+) http://([^/:]+)(:(\\d+))?(/\\S*)( HTTP/1\\.[01])");
    /**
     * HTTPNGXg̓CONNECT\bh̐K\
     */
    private static final Pattern CONNECT_METHOD_LINE_PATTERN = Pattern
            .compile("^CONNECT ([^:]+):(\\d+) HTTP/1\\.[01]");
    /**
     * CONNECT\bh̐̃X|X̐K\
     */
    private static final Pattern CONNECT_ESTABLISHED_PATTERN = Pattern
            .compile("^HTTP/1.[01] 200 Connection established");
    /**
     * Content-Lengthwb_̐K\
     */
    private static final Pattern CONTENT_LENGTH_PATTERN = Pattern
            .compile("(?i)\ncontent-length:\\s*(\\d+)\r?\n");
    /**
     * Keep-Alivewb_̐K\
     */
    private static final Pattern KEEP_ALIVE_PATTERN = Pattern
            .compile("(?i)\nKeep-Alive:\\s*\\d+\r?\n");
    /**
     * Proxy-Connectionwb_̐K\Bkeep-alivȅꍇB
     */
    private static final Pattern PROXY_CONNECTION_PATTERN = Pattern
            .compile("(?i)\nProxy-Connection:\\s*keep-alive\r?\n");
    /**
     * Rangewb_̐K\
     */
    private static final Pattern RANGE_PATTERN = Pattern
            .compile("(?i)\nRange:[^\n]*\r?\n");
    /**
     * ^Cg̐K\
     */
    private static final Pattern HTML_TITLE_PATTERN = Pattern
            .compile("<title>(?:jRjR\\([^-]]+[-]])?\\s*(.*?)</title>");

    /**
     * ݒ
     */
    private Config config;
    /**
     * uEUւ̐ڑB̈ԍŌɂ̃NXclose()B
     */
    private Socket browser;

    public ConnectionProcessor(Config config, Socket browser) {
        if (config == null) {
            throw new IllegalArgumentException("config must not be null");
        }
        if (browser == null) {
            throw new IllegalArgumentException("browser must not be null");
        }

        this.config = config;
        this.browser = browser;
    }

    /**
     * uEU1̐ڑB
     * 
     * @throws IOException
     */
    private void processSingle() throws IOException {
        // Buffered ɂƎ~܂
        InputStream browserInput = browser.getInputStream();

        StringBuilder request = readHeder(browserInput);
        if (request == null) {
            return;
        }

        int contentLength = getContentLength(request);

        Logger.debugWithThread("start "
                + request.toString().replaceFirst("(?s)(.*?)\r?\n.*", "$1"));

        int ch;
        int readContentLength = 0;
        while (readContentLength < contentLength
                && (ch = browserInput.read()) != -1) {
            request.append((char) ch);
            ++readContentLength;
        }

        // IEŃOCłȂ
        // browser.shutdownInput();

        String cacheId = null;
        String suffix = null;
        Matcher m = SM_FLV_PATTERN.matcher(request);
        if (m.lookingAt()) {
            cacheId = "sm" + m.group(1);
            suffix = m.group(2);
        }

        if (cacheId != null) {
            Cache cache = new Cache(cacheId);
            if (!cache.exists() && suffix != null) {
                cache = new Cache(cacheId + suffix);
            }

            if (cache.exists()) {
                Logger.info("using cache: " + cache.getCacheFileName());
                respondWithCache(cache);
            } else {
                if (config.isTitle() && cacheId.startsWith("sm")) {
                    String desc = getDescSmile(cacheId);

                    if (desc != null) {
                        if (suffix == null) {
                            cache = new Cache(cacheId, desc);
                        } else {
                            cache = new Cache(cacheId + suffix, desc);
                        }
                    }
                }

                Logger.info("no cache found: " + cache.getCacheFileName());
                respondViaServerStoring(request, cache);
            }
        } else {
            respondViaServer(request);
        }

        // browser.shutdownOutput();

        Logger.debugWithThread("end");
    }

    /**
     * SMILEVIDEO瓮̃^Cg擾B
     * 
     * @param cacheId
     * @return ̃^CgBȂꍇnullB
     * @throws UnknownHostException
     * @throws IOException
     */
    String getDescSmile(String cacheId) throws UnknownHostException,
            IOException {
        StringBuilder request = new StringBuilder();
        request.append("GET http://www.nicovideo.jp/thumb/" + cacheId
                + " HTTP/1.0\r\n");
        request.append("Host: www.nicovideo.jp\r\n");
        request.append("\r\n");
        Socket server = adjustRequestAndGetSocket(request);

        if (server == null) {
            return null;
        }

        try { // ensure closing server socket
            InputStream serverInput = sendRequest(request, server);
            ByteArrayOutputStream responseBuf = new ByteArrayOutputStream();

            StringBuilder responseHeader = sendAndGetResponseHeader(
                    serverInput, responseBuf);
            responseBuf.reset();

            int contentLength = getContentLength(responseHeader);
            // ProxomitronContent-LengtĥɎbΉ
            if (contentLength == 0) {
                contentLength = 3000;
            }

            int len;
            byte[] buf = new byte[BUF_SIZE];
            while (responseBuf.size() < contentLength
                    && (len = serverInput.read(buf)) != -1) {
                responseBuf.write(buf, 0, len);
            }
            String responseString = new String(responseBuf.toByteArray(),
                    "UTF-8");

            return getTitleFromResponse(responseString);

        } finally {
            server.close();
        }
    }

    /**
     * HTML^Cg擾B
     * 
     * @param html
     * @return ^CgBȂꍇnullB
     */
    String getTitleFromResponse(String html) {
        Matcher mTitle = HTML_TITLE_PATTERN.matcher(html);
        if (mTitle.find()) {
            return mTitle.group(1);
        } else {
            return null;
        }
    }

    /**
     * HTTP̃NGXg⃌X|XContent-Length擾B
     * 
     * @param httpHeaderPart
     * @return Content-Length̒l
     */
    private int getContentLength(StringBuilder httpHeaderPart) {
        int contentLength = 0;
        Matcher m = CONTENT_LENGTH_PATTERN.matcher(httpHeaderPart);
        if (m.find()) {
            contentLength = Integer.parseInt(m.group(1));
        }
        return contentLength;
    }

    /**
     * T[ỏLbVȂuEUɕԂB
     * 
     * @param request
     * @param cache
     * @throws IOException
     */
    private void respondViaServerStoring(StringBuilder request, Cache cache)
            throws IOException {
        Socket server = adjustRequestAndGetSocket(request);
        if (server == null) {
            return;
        }

        // DLƃLbVɓȂ̂RangeԂ
        // {͎LbV̒fЂĂ炻ꂩ烌W[悤ɂƂ
        Matcher mRange = RANGE_PATTERN.matcher(request);
        String nonRangeRequest = mRange.replaceFirst("\n");

        try { // ensure closing server socket
            InputStream serverInput = sendRequest(nonRangeRequest, server);
            OutputStream browserOutput = new BufferedOutputStream(browser
                    .getOutputStream());

            StringBuilder responseHeader = sendAndGetResponseHeader(
                    serverInput, browserOutput);

            if (!HTTP_OK_PATTERN.matcher(responseHeader).find()) {
                Logger.warning("invalid response:\r\n" + responseHeader);
                return;
            }

            BufferedOutputStream cacheOutput = new BufferedOutputStream(cache
                    .getTmpOutputStream());
            int len = 0;
            try { // ensure cache is clean
                byte[] buf = new byte[BUF_SIZE];
                while ((len = serverInput.read(buf)) != -1) {
                    browserOutput.write(buf, 0, len);
                    cacheOutput.write(buf, 0, len);
                }
                browserOutput.flush();
            } finally {
                try {
                    cacheOutput.close();
                } catch (IOException e) {
                    cache.deleteTmp();
                    Logger.debug(e);
                    return;
                }

                int contentLength = getContentLength(responseHeader);

                // NbL[nɂȂContent-Length: 0ɂȂĂ
                if (len != -1 || cache.tmpLength() != contentLength
                        || cache.tmpLength() == 0) {
                    cache.deleteTmp();
                    Logger.debugWithThread("delete incomplete cache");
                } else {
                    cache.store();
                    Logger.info("cache completed: " + cache.getCacheFileName());
                }
            }
        } finally {
            server.close();
        }
    }

    /**
     * T[õwb_uEUɑM擾B(obt@OȂB)
     * 
     * @param serverInput
     *            T[o
     * @param browserOutput
     *            uEU
     * @return T[ỏ̃wb_
     * @throws IOException
     */
    private StringBuilder sendAndGetResponseHeader(InputStream serverInput,
            OutputStream browserOutput) throws IOException {
        int ch;
        char[] hist = new char[4];
        int index = 0;
        StringBuilder responseHeader = new StringBuilder();
        while ((ch = serverInput.read()) != -1) {
            browserOutput.write(ch);
            responseHeader.append((char) ch);

            hist[index & 3] = (char) ch;
            if (hist[(index + 1) & 3] == '\r' && hist[(index + 2) & 3] == '\n'
                    && hist[(index + 3) & 3] == '\r'
                    && hist[(index) & 3] == '\n') {
                break;
            }
            index++;
        }
        return responseHeader;
    }

    /**
     * ɉȂŒpB
     * 
     * @param request
     * @throws IOException
     */
    private void respondViaServer(StringBuilder request) throws IOException {
        Matcher mConnect = CONNECT_METHOD_LINE_PATTERN.matcher(request);
        if (mConnect.find()) {
            String host = mConnect.group(1);
            int port = Integer.parseInt(mConnect.group(2));
            handleConnect(host, port);
            return;
        }

        Socket server = adjustRequestAndGetSocket(request);
        if (server == null) {
            return;
        }

        try { // ensure closing server socket
            InputStream serverInput = sendRequest(request, server);
            OutputStream browserOutput = new BufferedOutputStream(browser
                    .getOutputStream());
            int len;
            byte[] buf = new byte[BUF_SIZE];
            while ((len = serverInput.read(buf)) != -1) {
                browserOutput.write(buf, 0, len);
                // bZ[W̓e邽߂ad hock hack
                // if (request.toString().startsWith("POST")) {
                // System.out.write(buf, 0, len);
                // }
            }
            browserOutput.flush();
        } finally {
            server.close();
        }
    }

    /**
     * HTTP CONNECTB
     * 
     * @param host
     * @param port
     * @throws IOException
     */
    private void handleConnect(String host, int port) throws IOException {
        // Socket#isClosed()
        // Socket#isInputShutdown()
        // Socket#isOutputShutdown()
        // ̂łImłȂ̂
        // ̂߂ɔubNI/OgĎ
        SocketChannel sc = getServerChannelForConnect(host, port);
        if (sc == null) {
            return;
        }

        try {
            handleConnectOnChannel(sc);
        } finally {
            sc.close();
        }
    }

    /**
     * CONNECTBChannelclose₷邽߂ɕB
     * 
     * @param sc
     * @throws IOException
     */
    private void handleConnectOnChannel(SocketChannel sc) throws IOException {
        sc.configureBlocking(false);

        SocketChannel bc = browser.getChannel();

        // uEUɂƐ؂Ăق̂Connection, Proxy-Connection
        // tĂ݂邪ł̂sB
        String firstResponse = "HTTP/1.0 200 Connection established\r\n"
                + "Connection: close\r\n" + "Proxy-Connection: close\r\n"
                + "Proxy-agent: NicoCache\r\n" + "\r\n";
        ByteBuffer firstResponseBuffer = ByteBuffer.wrap(firstResponse
                .getBytes("ISO-8859-1"));
        bc.write(firstResponseBuffer);

        bc.configureBlocking(false);

        Selector sel = Selector.open();
        try {
            SelectionKey scKey = sc.register(sel, SelectionKey.OP_READ);
            SelectionKey bcKey = bc.register(sel, SelectionKey.OP_READ);
            scKey.attach(bc); // ő΂ɂȂ鑤擾ł悤ɂĂ
            bcKey.attach(sc);

            handleConnectOnSelector(sel);
        } finally {
            sel.close();
        }
    }

    /**
     * CONNECTBSelectorclose₷邽߂ɕB
     * 
     * @param sel
     * @throws IOException
     */
    private void handleConnectOnSelector(Selector sel) throws IOException {
        ByteBuffer bbuf = ByteBuffer.allocate(BUF_SIZE);
        int len;

        // L[Zbg0̏Ԃselect()ĂԂƉiɑ҂Ă܂B
        // ꂽL[Zbg͑I𑀍sȂƎۂɍ폜ȂB
        // ōXV邽߂selectNow()ĂԂ
        // select()̖߂l0ɂȂ邱ƂB
        int selcount;
        while ((selcount = sel.selectNow()) >= 0 && sel.keys().size() > 0
                && (selcount > 0 || sel.select() >= 0)) {
            Set<SelectionKey> selKeys = sel.selectedKeys();

            // for (SelectionKey key : selKeys)ƂȂ
            // ConcurrentModificationExceptionɂȂ邱Ƃ
            for (Iterator<SelectionKey> ite = selKeys.iterator(); ite.hasNext();) {
                SelectionKey key = ite.next();
                ite.remove();

                SocketChannel readCh = (SocketChannel) key.channel();
                SocketChannel writeCh = (SocketChannel) key.attachment();

                bbuf.clear();
                try {
                    len = readCh.read(bbuf);
                } catch (IOException e) {
                    // select()gĂ̂
                    // u̐ڑ̓[g zXgɋIɐؒf܂Bv
                    // Őؒf邱Ƃ͂ȂmȂ
                    // ÔߑΉĂ
                    len = -1;
                }

                if (len == -1) {
                    key.cancel();
                    writeCh.socket().shutdownOutput();
                } else {
                    bbuf.flip();
                    while (bbuf.hasRemaining()) {
                        writeCh.write(bbuf);
                    }
                }
            }
        }
    }

    /**
     * CONNECTŐڑT[oChannel擾B ݒɂProxyoRB
     * 
     * @param host
     *            ړIT[õzXg
     * @param port
     *            ړIT[õ|[g
     * @return ڑłȂꍇnull
     * @throws IOException
     */
    private SocketChannel getServerChannelForConnect(String host, int port)
            throws IOException {
        boolean completed = false;

        SocketChannel sc = SocketChannel.open();
        try { // ensure sc.close() in case of error.
            if (config.getProxyHost().equals("")) {
                sc.connect(new InetSocketAddress(host, port));
            } else {
                Socket proxy = sc.socket();
                proxy.connect(new InetSocketAddress(config.getProxyHost(),
                        config.getProxyPort()));
                String connectRequest = "CONNECT " + host + ":" + port
                        + "HTTP/1.0\r\n" + "\r\n";
                InputStream pin = sendRequest(connectRequest, proxy);
                StringBuilder response = readHeder(pin);
                if (response == null) {
                    return null;
                }

                Matcher mEstablished = CONNECT_ESTABLISHED_PATTERN
                        .matcher(response);
                if (!mEstablished.find()) {
                    Logger.warning("invalid response:\r\n" + response);
                    return null;
                }
            }

            completed = true;
            return sc;
        } finally {
            if (!completed) {
                sc.close();
            }
        }
    }

    /**
     * HTTPwb_ǂށB
     * 
     * @param in
     *            ǂށB
     * @return ǂ񂾃wb_BŌ̋s݁Bǂ߂Ȃꍇnull
     * @throws IOException
     */
    private StringBuilder readHeder(InputStream in) throws IOException {
        int ch;
        StringBuilder response = new StringBuilder();
        while ((ch = in.read()) != -1) {
            response.append((char) ch);

            if (ch == '\n') {
                if (response.toString().endsWith("\r\n\r\n")) {
                    break;
                }
            }
        }

        if (ch == -1) {
            return null;
        } else {
            return response;
        }
    }

    /**
     * T[ôւ̐ڑ擾Brequest𒲐B
     * 
     * @param request
     * @return T[oւ̐ڑBݒɂProxyoRB
     * @throws UnknownHostException
     * @throws IOException
     */
    private Socket adjustRequestAndGetSocket(StringBuilder request)
            throws UnknownHostException, IOException {
        Socket server;
        if (config.getProxyHost().equals("")) {
            Matcher m = METHOD_LINE_PATTERN.matcher(request);
            if (!m.find()) {
                Logger.warning("invalid request:\r\n" + request);
                return null;
            }

            String method = m.group(1);
            String host = m.group(2);
            int port;
            if (m.group(4) == null) {
                port = 80;
            } else {
                port = Integer.parseInt(m.group(4));
            }
            String path = m.group(5);
            String rest = m.group(6);

            String nonProxyMethodLine = method + " " + path + rest;

            request.replace(0, m.group(0).length(), nonProxyMethodLine);

            server = new Socket(host, port);

        } else {
            server = new Socket(config.getProxyHost(), config.getProxyPort());
        }

        // keep alive ΉȂ̂łԂ
        Matcher mKeep = KEEP_ALIVE_PATTERN.matcher(request);
        String nonKeepRequest = mKeep.replaceFirst("\n");
        Matcher mConnection = PROXY_CONNECTION_PATTERN.matcher(nonKeepRequest);
        // proxy, direct Ή̎蔲
        String nonConnectionRequest = mConnection
                .replaceFirst("\nProxy-Connection: close\r\nConnection: close\r\n");
        request.setLength(0);
        request.append(nonConnectionRequest);

        return server;
    }

    /**
     * T[oɑMB
     * 
     * @param request
     * @param server
     * @return T[ỏ
     * @throws IOException
     */
    private InputStream sendRequest(CharSequence request, Socket server)
            throws IOException {
        InputStream serverInput = new BufferedInputStream(server
                .getInputStream());
        OutputStream serverOutput = new BufferedOutputStream(server
                .getOutputStream());

        serverOutput.write(request.toString().getBytes("ISO-8859-1"));
        serverOutput.flush();
        return serverInput;
    }

    /**
     * T[oɃANZXɃLbV牞ԂB
     * 
     * @param cache
     * @throws IOException
     */
    private void respondWithCache(Cache cache) throws IOException {
        OutputStream browserOutput = new BufferedOutputStream(browser
                .getOutputStream());

        String responseHeader = "HTTP/1.0 200 OK\r\n" + "Content-Length: "
                + cache.length() + "\r\n" + "Content-Type: video/flv" + "\r\n" +
                // "Content-Disposition: attachment; filename=\"smile.flv\"" +
                // "\r\n" +
                "\r\n";
        InputStream content = new BufferedInputStream(cache.getInputStream());

        try { // ensure closing content
            browserOutput.write(responseHeader.getBytes("ISO-8859-1"));

            int len;
            byte[] buf = new byte[BUF_SIZE];
            while ((len = content.read(buf)) != -1) {
                browserOutput.write(buf, 0, len);
            }

            browserOutput.flush();
        } finally {
            content.close();
        }
    }

    /**
     * XbhGg|CgB
     * 
     * @see java.lang.Runnable#run()
     */
    public void run() {
        try { // ensure browser.close()
            processSingle();
        } catch (ConnectException e) {
            // T[oorvLVɐڑs
            Logger.warning(e.toString());
        } catch (SocketException e) {
            // Connection reset ͂悭̂Œʏ̓OɏoȂ
            if (e.getMessage().startsWith("Connection reset")
                    || e.getMessage().startsWith(
                            "Software caused connection abort")) {
                // ̔@ł́c
                Logger.debugWithThread(e);
            } else {
                Logger.error(e);
            }
        } catch (IOException e) {
            // NIOgĂConnection resetł͂Ȃȉ̃bZ[W
            // IOExceptionɂȂB
            // u̐ڑ̓[g zXgɋIɐؒf܂Bv
            // umꂽڑzXg Rs[^̃\EgEFAɂĒ~܂Bv
            Logger.debugWithThread(e);
        } catch (Exception e) {
            Logger.error(e);
        } finally {
            try {
                consumeBrowserInput();
                browser.close();
            } catch (IOException e) {
                Logger.error(e);
            }
        }
    }

    /**
     * ]ȃf[^𑗂ĂuEU΍B
     */
    private void consumeBrowserInput() {
        try {
            // ̏NIOgĂȂ̂Ƌʉ邽
            // java.net APIŏB
            // ̂߂ɔubN[hB
            SocketChannel bc = browser.getChannel();
            if (bc != null) {
                bc.configureBlocking(true);
            }

            // ̓ǂݍ݂ŃfbhbN邽ߏo͂͒~B
            // (FIN𑗐M)
            browser.shutdownOutput();

            // IEPOSTNGXg̎ɗ]CRLF𑗂ėĂ̂
            // IEM𐳏Ił悤ɓǂݔ΂ĂB
            // (FIN̎M܂ő҂)
            // ǂݔ΂ĂȂSocket#close()
            // ubZ[WT[o[ɐڑł܂łBvȂǂɂȂ
            // Ql: IE]CRLF𑗐M邱ƂɂĐG
            // Ă̕
            // http://support.microsoft.com/kb/823099/
            while (browser.getInputStream().read() != -1) {
                // no nothing
            }
        } catch (IOException e) {
            // Connection resetñG[B
            Logger.debugWithThread(e);
        }
    }
}
